/*
 * Copyright (c) 2015, 2016, 2017 Adrian Siekierka
 *
 * This file is part of Preston.
 *
 * Preston is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Preston is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Preston.  If not, see <http://www.gnu.org/licenses/>.
 */

package pl.asie.preston.client;

import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.OpenGlHelper;
import net.minecraft.client.renderer.RenderHelper;
import net.minecraft.client.renderer.block.model.IBakedModel;
import net.minecraft.client.renderer.block.model.ItemCameraTransforms;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraftforge.client.model.IModel;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.common.model.TRSRTransformation;
import org.lwjgl.opengl.GL11;
import pl.asie.preston.container.ItemCompressedBlock;
import pl.asie.preston.machine.BlockCompressor;
import pl.asie.preston.machine.TileCompressor;

public class TileRendererCompressor extends TileEntitySpecialRenderer<TileCompressor> {
	public static IModel pistonHead;

	@Override
	public void func_192841_a(TileCompressor tile, double x, double y, double z, float partialTicks, int destroyStage, float alpha) {
		if (tile == null) {
			return;
		}

		IBlockState state = func_178459_a().func_180495_p(tile.func_174877_v());
		ItemStack stackProcessed = tile.getStackHandler().getStackInSlot(0);

		GlStateManager.func_179094_E();
		GlStateManager.func_179137_b(x, y, z);

		GlStateManager.func_179109_b(0.5f, 0.5f, 0.5f);
		GlStateManager.func_179114_b(180.0f - state.func_177229_b(BlockCompressor.FACING).func_185119_l(), 0, 1, 0);
		GlStateManager.func_179109_b(-0.5f, -0.5f, -0.5f);

		GlStateManager.func_179141_d();
		GlStateManager.func_179145_e();
		GlStateManager.func_179092_a(GL11.GL_GREATER, 0.0F);
		GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
		Minecraft.func_71410_x().func_110434_K().func_110577_a(TextureMap.field_110575_b);

		if (pistonHead != null) {
			IBakedModel bakedModel = pistonHead.bake(TRSRTransformation.identity(), DefaultVertexFormats.field_176600_a, ModelLoader.defaultTextureGetter());

			GlStateManager.func_179094_E();
			GlStateManager.func_179109_b(0, 0.25f * ((255 - tile.armProgressClient) / 255.0f), 0);

			Minecraft.func_71410_x().func_175602_ab().func_175019_b().func_178262_a(
					bakedModel, 1.0f, 1.0f, 1.0f, 1.0f
			);

			GlStateManager.func_179121_F();
		}

		if (!stackProcessed.func_190926_b()) {
			GlStateManager.func_179094_E();
			GlStateManager.func_179114_b(90, 1, 0, 0);
			GlStateManager.func_179137_b(0.5, 0.5, -(7.25f/16f));
			if (tile.armProgressClient >= 128 && (stackProcessed.func_77973_b() instanceof ItemBlock || stackProcessed.func_77973_b() instanceof ItemCompressedBlock)) {
				GlStateManager.func_179109_b(0, 0, 0.25f * ((tile.armProgressClient - 128) / 255.0f));
			}
			GlStateManager.func_179152_a(0.5f, 0.5f, 0.5f);
			Minecraft.func_71410_x().func_175599_af().func_181564_a(stackProcessed, ItemCameraTransforms.TransformType.FIXED);
			GlStateManager.func_179121_F();
		}

		GlStateManager.func_179121_F();

		GlStateManager.func_179084_k();
	}
}
