/*
 * Copyright (c) 2015, 2016, 2017 Adrian Siekierka
 *
 * This file is part of Preston.
 *
 * Preston is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Preston is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Preston.  If not, see <http://www.gnu.org/licenses/>.
 */

package pl.asie.preston.container;

import net.minecraft.block.state.IBlockState;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.world.IBlockAccess;
import net.minecraftforge.common.util.Constants;
import pl.asie.preston.util.TileBase;

public class TileCompressedBlock extends TileBase {
	protected ItemStack containedStack = ItemStack.field_190927_a;
	protected int level;
	private FakeBlockAccess access;

	public ItemStack getDroppedBlock() {
		return ItemCompressedBlock.setLevel(containedStack, level);
	}

	public void initFromStack(ItemStack stack) {
		containedStack = ItemCompressedBlock.getContained(stack);
		level = ItemCompressedBlock.getLevel(stack);
		access = null;

		IBlockState state = field_145850_b.func_180495_p(field_174879_c);
		field_145850_b.func_184138_a(field_174879_c, state, state, 3);
	}

	public IBlockAccess getBlockAccess() {
		if (access == null) {
			access = new FakeBlockAccess(func_145831_w(), func_174877_v(), containedStack);
		}
		return access;
	}

	public ItemStack getContainedStack() {
		return containedStack;
	}

	public int getLevel() {
		return level;
	}

	@Override
	public void readNBTData(NBTTagCompound compound, boolean isClient) {
		if (compound.func_150297_b("stack", Constants.NBT.TAG_COMPOUND)) {
			containedStack = new ItemStack(compound.func_74775_l("stack"));
		} else {
			containedStack = ItemStack.field_190927_a;
		}

		level = compound.func_74762_e("level");
		access = null;

		if (isClient) {
			field_145850_b.func_175704_b(field_174879_c, field_174879_c);
		}
	}

	@Override
	public NBTTagCompound writeNBTData(NBTTagCompound compound, boolean isClient) {
		compound.func_74782_a("stack", containedStack.serializeNBT());
		compound.func_74768_a("level", level);
		return compound;
	}
}
