/*
 * Copyright (c) 2015, 2016, 2017 Adrian Siekierka
 *
 * This file is part of Preston.
 *
 * Preston is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Preston is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Preston.  If not, see <http://www.gnu.org/licenses/>.
 */

package pl.asie.preston.util;

import net.minecraft.block.Block;
import net.minecraft.block.material.MapColor;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Enchantments;
import net.minecraft.item.ItemStack;
import net.minecraft.stats.StatList;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.NonNullList;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import javax.annotation.Nullable;

public abstract class BlockBase extends Block {
	public BlockBase(Material materialIn) {
		super(materialIn);
	}

	public BlockBase(Material materialIn, MapColor mapColor) {
		super(materialIn, mapColor);
	}

	public final void getDrops(NonNullList<ItemStack> drops, IBlockAccess world, BlockPos pos, IBlockState state, int fortune) {
		getDrops(drops, world, pos, state, null, fortune, false);
	}

	public void getDrops(NonNullList<ItemStack> drops, IBlockAccess world, BlockPos pos, IBlockState state, @Nullable TileEntity te, int fortune, boolean silkTouch) {
		super.getDrops(drops, world, pos, state, fortune);
	}

	@Override
	public void func_180657_a(World worldIn, EntityPlayer player, BlockPos pos, IBlockState state, @Nullable TileEntity te, ItemStack stack) {
		player.func_71029_a(StatList.func_188055_a(this));
		player.func_71020_j(0.005F);
		int fortuneLevel = EnchantmentHelper.func_77506_a(Enchantments.field_185308_t, stack);
		boolean silkTouch = EnchantmentHelper.func_77506_a(Enchantments.field_185306_r, stack) > 0;

		NonNullList<ItemStack> items = NonNullList.func_191196_a();
		getDrops(items, worldIn, pos, state, te, 0, false);
		float chance = net.minecraftforge.event.ForgeEventFactory.fireBlockHarvesting(items, worldIn, pos, state, fortuneLevel, 1.0f, silkTouch, player);

		harvesters.set(player);

		if (!worldIn.field_72995_K && !worldIn.restoringBlockSnapshots) {
			for (ItemStack item : items)
				if (chance >= 1.0f || worldIn.field_73012_v.nextFloat() <= chance)
					func_180635_a(worldIn, pos, item);
		}

		harvesters.set(null);
	}
}
